//------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 SlateGray
#property indicator_color3 SlateGray
#property indicator_color4 SlateGray
//-------------------------------------
extern int Points = 40;
extern double Percent = 0;
extern bool chHL = true;
extern bool Texts = true;
extern color color_ZZ = Blue;
extern color color_txt = Black; 
//------------------------
double zz[],hm,lm,ha[],la[],sa[];
double fxH[],fxL[],di;
int fs,ai,bi;
double HL,HLp,HL1,k,k0;
//***************************************
int init() 
{

   IndicatorBuffers(6);
   SetIndexStyle(0,1,0,3,color_ZZ);
   SetIndexBuffer(0,zz);
   SetIndexEmptyValue(0,0.0); 
   SetIndexBuffer(1,ha);
   SetIndexBuffer(2,la);
   SetIndexStyle(3,DRAW_LINE,2);  
   SetIndexBuffer(3,sa);
   SetIndexBuffer(4,fxH);
   SetIndexBuffer(5,fxL);

   if (chHL==false) 
   {
    SetIndexDrawBegin(1,2*Bars); 
    SetIndexDrawBegin(2,2*Bars); 
    SetIndexDrawBegin(3,2*Bars);
   }
   else
   {
    SetIndexDrawBegin(1,1); 
    SetIndexDrawBegin(2,1); 
    SetIndexDrawBegin(3,1);
   }
  
   if (Points!=0 && Percent==0) di=Points*Point;

   if (Texts) 
   {
    ObjectCreate("AZZfx0",OBJ_TEXT,0,Time[0],Close[0]); 
    ObjectCreate("AZZfx1",OBJ_TEXT,0,Time[0],Close[0]+0.0004);
   }

   return(0); 
}

//********************************************************
int start() 
{
    
   int i,n;
   int counted_bars=IndicatorCounted();
   if (counted_bars<0) {Print("Indicator Error (Counted bars < 0)!" ); return(-1); }
   if (Bars<100) {Print("Indicator Error (Bars < 100)!" ); return(-1); }
   int cbi=Bars-2;
   if (counted_bars>2) {cbi=Bars-counted_bars-1; }

//======================================================================================================================
//-----------------Functions------------------------------   
   for (i=cbi; i>=0; i--) 
   {
      fxH[i]=High[i];  
      fxL[i]=Low[i];
   }
//========================================================
//========================================================
   for (i=cbi; i>=0; i--) 
   {
      //------------------------------------------------------
      if (Points!=0 && Percent!=0) return(0);
      if (Points==0 && Percent!=0) di=Percent*NormalizeDouble(Close[i],3)/100;
      //-------------------Trigger----------------------------
      if (i>Bars-5) {hm=fxH[i]; lm=hm-di; ai=i; bi=i+1; fs=0;}
      //======================================================================
     
      if (fxH[i]-fxL[i]>=di) 
      { 
         //------------1---------------
       
         if ((fxH[i]+fxL[i])/2>=(ha[i+1]+la[i+1])/2) 
         {
            hm=fxH[i]; 
            lm=hm-di; 
            if (fs==2) {zz[bi]=Low[bi]; if (Texts) af_txt(1,fs);} 
            ai=i; 
            fs=1;
         } 
         
         else 
         //------------2---------------
         { 
            lm=fxL[i]; 
            hm=lm+di; 
            if (fs==1) {zz[ai]=High[ai]; if (Texts) af_txt(1,fs);}
            bi=i; 
            fs=2;
         }
      } 
     
      else 
     
      //------------------------fs=1----------------------------------
      if (fxH[i]>hm) 
      {
         hm=fxH[i]; 
         lm=hm-di; 
         if (fs==2) {zz[bi]=Low[bi]; if (Texts) af_txt(1,fs);} 
         ai=i; 
         fs=1;
      }
      else
      //-------------------------fs=2---------------------------------
      if (fxL[i]<lm) 
      { 
         lm=fxL[i]; 
         hm=lm+di; 
         if (fs==1) {zz[ai]=High[ai]; if (Texts) af_txt(1,fs);}
         bi=i; 
         fs=2;
      }
      //----------------------------------------------------------------
     
      ha[i]=hm; 
      la[i]=lm;
      sa[i]=(ha[i]+la[i])/2;
      
      //======================i=0======================================== 
      if (i==0) 
      {
         if (ai!=0 || bi!=0) 
         {
            for (n=0; n<=ai+1; n++) if (ha[n]>ha[n+1]) {ai=n; break;}
            for (n=0; n<=bi+1; n++) if (la[n]<la[n+1]) {bi=n; break;}
         }

         if (fs==1) for (n=0; n<=bi; n++) zz[n]=0.0;
         if (fs==2) for (n=0; n<=ai; n++) zz[n]=0.0;

         zz[0]=Close[0];
         zz[ai]=fxH[ai];
         zz[bi]=fxL[bi];

         if (Texts) af_txt(0,fs); 
      }
   } //---for
//====================================================================================================
   //Comment("fs = ",fs,"\n","fss = ",fss,"\n","ai = ",ai,"\n","bi = ",bi);
   return(0); 
}
//*************************************************************************************************
void af_txt(int index, int fs)
{
   if (index==1)
   {
      if (fs==1)
      {
         HLp=HL; 
         HL=fxH[ai]-fxL[bi];
         if (HLp!=0) k=HL/HLp;

         ObjectCreate("AZZfx"+Time[ai],OBJ_TEXT,0,Time[ai],High[ai]+0.0007);
         ObjectSetText("AZZfx"+Time[ai]," "+DoubleToStr(k,2),8,"Arial",color_txt); 
      }
      
      if (fs==2)
      {
         HLp=HL; 
         HL=fxH[ai]-fxL[bi];
         if (HLp!=0) k=HL/HLp;

         ObjectCreate("AZZfx"+Time[bi],OBJ_TEXT,0,Time[bi],Low[bi]-0.0003);
         ObjectSetText("AZZfx"+Time[bi]," "+DoubleToStr(k,2),8,"Arial",color_txt);
      }
   }
    
   if (index==0)
   {
      HL1=fxH[ai]-fxL[bi];
      if (HL!=0) k=HL1/HL;

      if (fs==1) 
      {
         ObjectMove("AZZfx1",0,Time[ai],High[ai]+0.0007);
          
         if (ai!=0)  
         {
            k0=MathAbs((fxH[ai]-Close[0])/HL1);
            ObjectMove("AZZfx0",0,Time[0],Low[0]-0.0003);
         }  
         else
         ObjectMove("AZZfx0",0,Time[0],0);
      } 

      if (fs==2) 
      {
         ObjectMove("AZZfx1",0,Time[bi],Low[bi]-0.0003);
          
         if (bi!=0) 
         {
            k0=MathAbs((fxL[bi]-Close[0])/HL1);
            ObjectMove("AZZfx0",0,Time[0],High[0]+0.0007);
         }
         else 
         ObjectMove("AZZfx0",0,Time[0],0);
      }
           
      ObjectSetText("AZZfx1"," "+DoubleToStr(k,2),8,"Arial",Lime);
      ObjectSetText("AZZfx0"," "+DoubleToStr(k0,2),8,"Arial",Orange);
   }
    return;
}
//*************************************************
int deinit() {ObjectsDeleteAll(0,21); return(0);}
//*************************************************